function love.load()
	screenMatrix ={}
	
	for i=0, 256 do
		screenMatrix[i] = {}
		for j=0, 256 do
			screenMatrix[i][j] = false
		end
	end
	index = 1
	
	bgm = love.audio.newSource("TI84_Bad_Apple.compat.it")
	
	
	next_time = love.timer.getTime()
	Count = 1
	drawCount = 0
	unlockFPS = false
	flipOptimize = true
	encoderTime = 0
	Flip = true
	fileDropped = false
	audioPlayed = false
end

function love.update(dt)
	if unlockFPS then
		min_dt = 1/600
	else
		min_dt = 1/30
	end
	
	if fileDropped then
		
		
		if love.keyboard.isDown("u") then
			unlockFPS = not unlockFPS
		end
		
		if love.keyboard.isDown("s") then
			flipOptimize = not flipOptimize
		end
		
		next_time = next_time + min_dt
		encoderTimeStart = love.timer.getTime()
		Count = Count + 1
		print("Frame data position: "..index.. " Frame number: "..Count)
		value = string.byte(fileData, index)
		if Count < 6387 then
			repeat
				valX = value
				index = index + 1
				value = string.byte(fileData, index)
				valY = value
				index = index + 1
				value = string.byte(fileData, index)
				--print(valX, valY)
				screenMatrix[valX][valY] = not screenMatrix[valX][valY] --FLIP THAT PIXEL MOFO
			until(value < valX)
			encoderTime = love.timer.getTime() - encoderTimeStart
			if Count == 405 then
				print("Special frame! Holding for 30ms..")
				love.timer.sleep(0.30)
			end
			if Count == 3241 then
				print("Special frame! Holding for 2600ms...")
				love.timer.sleep(2.6)
			end
			if not audioPlayed then
				bgm:setVolume(1)
				bgm:play()
				audioPlayed = true
			end
		end
	end
end

function love.draw()
	drawCount = 0
	if Flip then
		love.graphics.setColor(0, 0, 0)
		love.graphics.setBackgroundColor(255, 255, 255)
		for x=0,255 do
				for y=0,255 do
					if screenMatrix[x][y] == false then
						love.graphics.rectangle("fill", x*3, y*3, 3, 3)
						drawCount = drawCount + 1
					end
				end
			end
	else
		love.graphics.setColor(255, 255, 255)
		love.graphics.setBackgroundColor(0, 0, 0)
		for x=0,255 do
			for y=0,255 do
				if screenMatrix[x][y] == true then
					love.graphics.rectangle("fill", x*3, y*3, 3, 3)
					drawCount = drawCount + 1
				end
			end
		end
	end
	
	if flipOptimize then
		if drawCount >= 32768 then
			Flip = not Flip
		end
	end
	
	love.graphics.setColor(255, 0, 128, 255)
	if fileDropped then
		love.graphics.print("FPS: "..love.timer.getFPS())
		love.graphics.print("Draw count: "..drawCount, 0, 10)
		love.graphics.print("Flip: "..tostring(Flip), 0, 20)
		love.graphics.print("Decoder time: "..encoderTime*1000, 0, 30)
		love.graphics.print("FPS limit: "..tostring(unlockFPS), 0, 40)
		love.graphics.print("Switch Logic: "..tostring(flipOptimize), 0, 50)
	else
		love.graphics.print('Drop "badapple.video" in this window to begin playback.')
		love.graphics.print("Controls:", 0, 10)
		love.graphics.print("[U] to disable Framelimiter.", 0, 20)
		love.graphics.print("[S] to disable ColorFlip optimization.", 0, 30)
	end
	local cur_time = love.timer.getTime()
	if next_time <= cur_time then
		next_time = cur_time
		return
	end
	love.timer.sleep(next_time - cur_time)

end

function love.filedropped(file)
	file:open("r")
	fileData, size = file:read()
	fileDropped = true
end